import binascii

from xml.sax import saxutils
from xml.sax import ContentHandler

class ReadPyringXML( saxutils.DefaultHandler ) :

    def __init__(self, version, hash, records ) :
        self.version, self.hash, self.records = version, hash, records
        self.recordsContent = 0
        self.recordContent = 0
        self.versionContent = 0
        self.hashContent = 0
        self.nameContent = 0
        self.dataContent = 0
        #print "Init pyring XML"

        
    def startElement( self, name, attrs ) :

        if name == 'version' :
            self.versionContent = 1
        elif name == 'hash' :
            self.hashContent = 1
            #self.hash = []
        elif name == 'records':
            self.recordsContent = 1
        elif name == 'record':
            self.record = []
            self.recordContent = 1
        elif name == 'name' :
            if not self.recordContent :
                print "Badly formed XML missing record tag"

            self.nameContent = 1
            self.name = ''
        elif name == 'data' :
            if not self.recordContent :
                print "Badly formed XML missing record tag"

            self.dataContent = 1
            self.data = ''
        else :
            print "Unknown tag <", name, ">"
    
    def endElement( self, name ) :
        if name == 'version' :
            self.versionContent = 0
        elif name == 'hash' :
            self.hashContent = 0
        elif name == 'records' :
            self.recordsContent = 0
        elif name == 'record':
            if self.nameContent :
                print "Badly formed XML missing name tag"

            if self.dataContent :
                print "Badly formed XML missing data tag"
            
            self.record = [ self.name, self.data ]
            self.records.append( self.record )
            self.recordContent = 0
        elif name == 'name' :
            self.nameContent = 0
            self.name = binascii.a2b_hex( self.name )
        elif name == 'data' :
            self.dataContent = 0
            self.data = binascii.a2b_hex( self.data )
        else :
            print "Unknown tag ", name
    
    def characters( self, ch ) :
        if self.hashContent :
            self.hash.append( binascii.a2b_hex( ch ))
        if self.versionContent :
            self.version.append( ch )
        if self.nameContent :
            self.name = self.name +ch
        if self.dataContent :
            self.data = self.data +ch
        #print "ch : ", ch.encode( "hex" )

    def error(self, exception):
        import sys
        sys.stderr.write("\%s\n" % exception)

